
#include "Registry.h"

void CRegCntrl::WriteString(HKEY prefixkey, char *szLocation, char *szVarName, const char *szValue)
{
	HKEY hKey;
	DWORD dwDispostion; 
	if ( RegCreateKeyEx(	prefixkey,
							szLocation,
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_WRITE,
							0, 
							&hKey, 
							&dwDispostion ) == ERROR_SUCCESS )
	{
		RegSetValueEx(hKey, szVarName, 0, REG_SZ, (LPBYTE)(LPCSTR)szValue, strlen(szValue)+1);
		RegCloseKey(hKey);
	}
}

bool CRegCntrl::ReadString(HKEY prefixkey, char *szLocation, char *szVarName, char *szValue)
{
	bool bRet = false;
	DWORD size = 260;
	HKEY hKey;

	if ( RegOpenKeyEx(prefixkey, szLocation, 0, KEY_READ, &hKey) == ERROR_SUCCESS )
	{
		if ( RegQueryValueEx(hKey, szVarName, 0, 0, (LPBYTE)szValue, &size) == ERROR_SUCCESS )
			bRet = true;
		RegCloseKey(hKey);
	}

	return bRet;
}

void CRegCntrl::WriteDWORD(HKEY prefixkey, char *szLocation, char *szVarName, DWORD dwValue)
{
	HKEY hKey;
	DWORD dwDispostion; 
	if ( RegCreateKeyEx(	prefixkey,
							szLocation,
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_WRITE,
							0, 
							&hKey, 
							&dwDispostion ) == ERROR_SUCCESS )
	{
		RegSetValueEx(hKey, szVarName, 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
		RegCloseKey(hKey);
	}
}

void CRegCntrl::DeleteValue(HKEY prefixkey, char *szLocation, char *szVarName)
{
	HKEY hKey;
	DWORD dwDispostion; 
	if ( RegOpenKeyEx(prefixkey, szLocation, 0, KEY_READ | KEY_WRITE, &hKey) == ERROR_SUCCESS )
	{
		RegDeleteValue(hKey, szVarName);
		RegCloseKey(hKey);
	}
}

bool CRegCntrl::ReadDWORD(HKEY prefixkey, char *szLocation, char *szVarName, DWORD *dwValue)
{
	bool bRet = false;
	DWORD size = sizeof(DWORD);
	HKEY hKey;

	if ( RegOpenKeyEx(prefixkey, szLocation, 0, KEY_READ, &hKey) == ERROR_SUCCESS )
	{
		if ( RegQueryValueEx(hKey, szVarName, 0, 0, (LPBYTE)dwValue, &size) == ERROR_SUCCESS )
			bRet = true;
		RegCloseKey(hKey);
	}

	return bRet;
}

