// VC1OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WMNicEnc.h"
#include "VC1OptionsDlg.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CVC1OptionsDlg dialog

#define NOT_SET_VALUE 500
#define EDIT_BOX 501
#define MAX_VALUES 40
#define NOT_SET_TEXT "Default"

CVC1OptionsDlg::CVC1OptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVC1OptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVC1OptionsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CVC1OptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVC1OptionsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


// HACK
BEGIN_MESSAGE_MAP(CVC1OptionsDlg, CDialog)
	//{{AFX_MSG_MAP(CVC1OptionsDlg)
	ON_CBN_SELCHANGE(0xff, OnSelChangeCOT)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVC1OptionsDlg message handlers

struct stVC1Options
{
	const char *szName;
	const char *szDescription;
	const char *szOptions;
	int nPossibleValues[MAX_VALUES];
};

stVC1Options VC1Options[] =
{
	// Compression Optimization Type
	{ "Compression Optimization Type", 
	  "The Compression Optimization Type registry setting specifies the type of optimization to use. This value is a preset selection of values for the other registry settings. If you explicitly set one of the affected settings, that set value will override the preset specified by this setting.",
	  "0 = The codec will not force optimization and will use whatever features are specified in other registry settings. In many cases, the codec will use internal logic to determine settings if they are not specified in the registry. This is the default value.\n1 = Enables the features that will produce the best visual quality.\nUsing this value configures the codec as if you had set the following registry settings:\nMotion Search Level = 1\nMotion Match Method = -1\nDquant Option = 2\nMotion Search Range = -1\nNumBFrames = 1\nMotion Vector Cost Method = 1\nForce LoopFilter = 1\nIf any of the settings in the previous list are set in the registry, the value in the registry overrides the values associated with this setting.",
	{  0, 1, NOT_SET_VALUE }
	},

	// DenoiseOption
	{ "DenoiseOption", 
	  "The DenoiseOption registry setting specifies whether the codec will use the noise filter when encoding. The noise filter attempts to detect and remove noise from the video frames.\nSome types of noise are easier than others for the codec to detect. Using this feature may result in lower video quality.",
	  "This registry setting must be set to 0 or 1. 0 indicates that the codec will not use the noise filter; 1 indicates that it will.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Dquant Option
	{ "Dquant Option", 
	  "The Dquant Option registry setting specifies when to use dquant perceptual optimization. Dquant is the difference in the quantizer between the previous macroblock and current macroblock. Using this optimization can produce better quality in smooth areas of the video picture, but increases the computation required to encode each frame.\n\nIf this optimization is activated, the strength of optimization is controlled by the Dquant Strength value.",
	  "0 = Dquant perceptual optimization will not be used.\n1 = Only I frames will be optimized.\n2 = I and P frames will be optimized, but B frames will not.\n3 = I, P, and B frames will be optimized.",
	  { 0, 1, 2, 3, NOT_SET_VALUE }
	},


	// Dquant Strength
	{ "Dquant Strength", 
	  "The Dquant Strength registry setting specifies the strength of the Dquant perceptual optimization that will be used. The stronger the optimization, the more CPU-intensive the encoding will be.\n\nThis value is used only if the Dquant Option value is set to 1, 2, or 3. The value of Dquant Option specifies the types of frames that will be optimized.",
	  "0 = The codec will determine the strength of optimization.\n1 = Weak optimization.\n2 = Medium optimization.\n3 = Strong optimization.",
	  { 0, 1, 2, 3, NOT_SET_VALUE }
	},

	// Force B Frame Delta QP
	{ "Force B Frame Delta QP", 
	  "The Force B Frame Delta QP registry setting specifies the delta increase between the picture quantizer of the anchor frame and the picture quantizer of the B frame.",
	  "This registry setting must be set to a value from 0 to 31",
	  { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, NOT_SET_VALUE }
	},

	// Force LoopFilter
	{ "Force LoopFilter", 
	  "The Force LoopFilter registry setting specifies whether the codec should use the in-loop deblocking filter during encoding.\n\nWhen the codec uses the in-loop deblocking filter, the edges of the macroblocks in the output video frames will not be as noticeable. However, the filter makes the image softer in appearance.",
	  "This registry setting must be set to 0 or 1. 0 indicates that the codec will not use the loop filter; 1 indicates that it will.",
	{ 0, 1, NOT_SET_VALUE }
	},

	// Force Median
	{ "Force Median", 
	  "The Force Median registry setting specifies whether the codec should use median filtering during encoding. Median filtering can reduce the encoded size of the video stream, but can introduce compression artifacts. The artifacts associated with this filter can include motion trails behind moving objects in the image.\n\nBy default, the codec uses internal logic to determine whether median filtering should be used. If you add this setting to the registry, that logic will be overridden and the codec will always abide by the value in the registry setting.",
	  "This registry setting must be set to 0 or 1. 0 indicates that the codec will not use median filtering; 1 indicates that it will.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Force NoiseEdgeRemoval
	{ "Force NoiseEdgeRemoval", 
	  "The Force NoiseEdgeRemoval registry setting specifies whether the codec should attempt to detect noisy frame edges and remove them.\n\nA noisy frame edge is usually the vertical blanking interval (VBI) data from a frame of broadcast television. The VBI is the first 21 scan lines of the television frame. These scan lines do not contain video datathey contain data about the broadcast. When a television signal is recorded by a capture card, the VBI is usually removed from the frame. The noisy edge detection and correction performed by the codec can only correct an edge that has three or fewer lines of noise. If captured video contains more than three noisy lines, there is a problem with the hardware used to capture the video.\n\nIf the codec is set to remove noisy edges, it duplicates lines adjacent to the noisy edge to fill in the frame.",
	  "This registry setting must be set to 0 or 1. 0 indicates that the codec will not remove edge noise; 1 indicates that it will.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Force NumThreads
	{ "Force NumThreads", 
	  "The Force NumThreads registry setting specifies the number of threads that the codec will use for encoding. This value is intended to divide encoding into multiple threads to take advantage of computers with multiple processors.\n\nSplitting encoding tasks into multiple threads can cause a slight decrease in quality as compared to a single thread.",
	  "This registry setting should be set to 1, 2, or 4. Other values will be rounded down.",
	  { 1, 2, 4, NOT_SET_VALUE }
	},

/*	// Force Range Reduction
	{ "Force Range Reduction", 
	  "The Force Range Reduction registry setting specifies the degree to which the codec should reduce the effective color range of the video. Reducing the color range reduces the encoded size of video frames but can introduce blurriness in the decoded frames.\n\nWithout this value set in the registry, the codec determines whether to use range reduction at encoding time. Typically this option is selected by the codec only at low bit rates.",
	  "This registry setting is a combination of four values, separated by zeros, formatted as 0x0M0m0N0n, where:\nM is the encoding range reduction factor for the Y component.\nm is the decoding range expansion factor for the Y component (usually the same as M).\nN is the encoding range reduction factor for the UV component.\nn is the decoding range expansion factor for the UV component (usually the same as N).\n\nEach factor is a digit from 0 to 8, where 0 is no reduction or expansion and 8 is the maximum reduction or expansion.\nIf you set the value to 0x00000000, range reduction is completely disabled.\nIf you set the value to 0xFFFFFFFF, the codec ignores the registry setting and uses its internal logic to determine whether range reduction should be used.",
	  { 0, 1, NOT_SET_VALUE }
	},
*/
	// Force Overlap
	{ "Force Overlap", 
	  "The Force Overlap registry setting specifies whether the codec will use overlap smoothing when encoding.",
	  "This registry setting must be set to 0 or 1. 0 indicates that overlap smoothing will not be used, 1 indicates that it will.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Force Video Scaling
	{ "Force Video Scaling", 
	  "The Force Video Scaling registry setting specifies whether the codec will use video scaling optimization. Video scaling is a type of perceptual optimization that can improve the visual quality of video encoded at low bit rates.",
	  "0 = Video scaling will not be used.\n1 = The encoder will use conservative video scaling optimization.\n2 = The encoder will use aggressive video scaling optimization.",
	  { 0, 1, 2, NOT_SET_VALUE }
	},

	// Lookahead
	{ "Lookahead", 
	  "The Lookahead registry setting specifies the number of frames after the current frame that the codec will evaluate before encoding the current frame. When the codec uses lookahead, it can encode the video more efficiently.\n\nThe writer object of the Windows Media Format SDK expects the codec to encode each sample immediately. As a result, this feature does not work properly in software that uses the writer object (including Windows Media Encoder and Windows Media Player). Any data unit extensions associated with video frames will be attached to the wrong output frame. The number of frames by which the data unit extensions are misplaced is equal to the number of frames of lookahead that are used.",
	  "This registry setting value is the number of frames of lookahead to use. It can be set to 0 to disable lookahead, or to any integer from 1 to 16 to enable that many frames of lookahead.",
	  { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, NOT_SET_VALUE }
	},

		
	// Macroblock Mode Cost Method
	{ "Macroblock Mode Cost Method", 
	  "The Macroblock Mode Cost Method registry setting specifies the cost method used by the codec to determe which macroblock mode to use.",
	  "0 = SAD/Hadamard. This option configures the codec to use only distortion when computing cost.\n1 = RD cost. This option configures the codec to account for both rate and distortion when computing cost.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Motion Match Method
	{ "Motion Match Method", 
	  "The Motion Match Method registry setting specifies the method to use for motion matching.",
	  "0 = SAD\n1 = Hadamard\n-1 = Macroblock-adaptive. This option configures the codec to make decisions about which method to use on each macroblock. This can potentially reduce overall computation required for encoding by performing the computationally-intensive Hadamard transform only when appropriate.",
	  { 0, 1, -1, NOT_SET_VALUE }
	},

	// Motion Search Level
	{ "Motion Search Level", 
	  "The Motion Search Level registry setting specifies the types of video information that are used in motion search operations.",
	  "0 = Luma only.\n1 = Luma with nearest-integer chroma.\n2 = Luma with true chroma.\n-1 = Macroblock-adaptive with true chroma.\n-2 = Macroblock-adaptive with nearest-integer chroma.",
	  { 0, 1, 2, -1, -2, NOT_SET_VALUE }
	},

	// Motion Search Range
	{ "Motion Search Range", 
	  "The Motion Search Range registry setting specifies the range used in motion searches.",
	  "0 = +63.75/-64.0 H, +31.75/-32.0 V\n1 = +127.75/-128.0 H, +63.75/-64.0 V\n2 = +511.75/-512.0 H, +127.75/-128.0 V\n3 = +1023.75/-1024.0 H, +255.75/-256.0 V\n-1 = Macroblock-adaptive",
	  { 0, 1, 2, 3, -1, NOT_SET_VALUE }
	},

	// Motion Vector Coding Method
	{ "Motion Vector Coding Method", 
	  "The Motion Vector Coding Method registry setting specifies the method used to code the motion vector information in field pictures.",
	  "0 = Use encoder defaults.\n1 = Improves coding efficiency for highly spread-out horizontal delta motion vector distributions.\n2 = Improves coding efficiency for highly spread-out vertical delta motion vector distributions.\n3 = Improves coding efficiency for highly spread-out horizontal and vertical delta motion vector distributions.",
	  { 0, 1, 2, 3, NOT_SET_VALUE }
	},

	// NumBFrames
	{ "NumBFrames", 
	  "The NumBFrames registry setting specifies the number of bidirectional predictive frames (B-frames) that the codec will use between other types of frames. As a default, the codec does not use B-frames. It uses only intraframes (I-frames), which are fully encoded frames, and predictive frames (P-frames), which are encoded as the differences from the previous frame. B-frames, like P-frames, are predictive and store the changes from other frames. B-frames are different from P-frames because they store both the differences from the previous frame and the differences from the following frame.\n\nThe primary advantage of using B-frames is that an error in a B-frame will not propagate to subsequent frames as an error in a P-frame will.\n\nWhen you configure the codec to use B-frames, it will use the specified number of B-frames between each pair of frames of either of the other types. For example, if a sequence of frames without B-frames is IPPPPPPPPPPI, the same sequence using two B-frames might be IBBPBBPBBI. Note that the presence of B-frames can alter the number of delta frames (P-frames or B-frames) between I-frames. In the right circumstances, this could cause the configured key-frame distance to be exceeded by a few frames.\n\nThe writer object of the Windows Media Format SDK expects the codec to encode each sample immediately. As a result, this feature does not work properly in software that uses the writer object (including Windows Media Encoder and Windows Media Player). Any data unit extensions associated with video frames will be attached to the wrong output frame. The number of frames by which the data unit extensions are misplaced is equal to the number of B-frames that are used.",
	  "This value is the number of B-frames to use between other types of frames. It can range from 0 to 7, with 0 indicating that B-frames will not be used.",
	  { 0, 1, 2, 3, 4, 5, 6, 7, NOT_SET_VALUE }
	},

	// Perceptual Option
	{ "Perceptual Option", 
	  "The Video Type registry setting specifies the logic that the codec will use to detect interlaced source video.",
	  "This registry setting must be set to 0 or 1. 0 indicates that the codec will not use conservative perceptual optimization; 1 indicates that it will.",
	  { 0, 1, NOT_SET_VALUE }
	},

	// Video Type
	{ "Video Type", 
	  "The Video Type registry setting specifies the logic that the codec will use to detect interlaced source video.",
	  "0 = The codec will use the standard frame-type detection logic.\n1 = The codec will treat all source video frames as interlaced frames.\n2 = The codec will treat all source video frames as fields of interlaced video.\n3 = The codec will automatically determine whether input video frames are interlaced frames or fields of interlaced video.\n4 = The codec will automatically determine whether input video frames are progressive frames, interlaced frames, or fields of interlaced video.",
	  { 0, 1, 2, 3, 4, NOT_SET_VALUE }
	},

	// SPECIAL/HACK: SPECIAL_COMPLEXITY_SETTING
	{ SPECIAL_COMPLEXITY_SETTING, 
	  "WMNicEnc Only! This will set the encoding complexity to the minimum level (for speed) or maximum level (for quality)\n(This will be effective for all video codecs not just VC-1)",
	  "N/A = Default Complexity level for the codec\n0 = Minimum Complexity Level (Fastest/Worst Quality)\n1 = Maximum Complexity (Slowest/Best Quality)",
	  { 0, 1, 2, 3, 4, 5, NOT_SET_VALUE }
	},

	// SPECIAL/HACK: SPECIAL_BUFFER_WINDOW_SIZE
	{ SPECIAL_BUFFER_WINDOW_SIZE, 
	  "WMNicEnc Only! This will set the Buffer Size used in Encoding. It specifies the maximum latency between when a stream is received and when it begins to be displayed. However, For video streams, a larger buffer window gives higher quality.",
	  "Size in MilliSeconds (Default: 3000)",
	  { EDIT_BOX, 3000 }
	}
};

int FindOptionNum(CString csOption)
{
	for ( int i = 0; i != sizeof(VC1Options)/sizeof(stVC1Options); i++ )
	{
		if ( csOption.CompareNoCase(VC1Options[i].szName) == 0 )
			return i;
	}
	return -1;
}


void CVC1OptionsDlg::CreateOption(const char *szText, int nLine, const char *szDescription, const char *szOptions, int *nPossibleValues, bool bEdit)
{
	CStatic*	pStatic = new CStatic;
	CComboBox*	pCombo	= NULL;
	CEdit*		pEdit	= NULL;


	CRegCntrl Reg;
	DWORD dwValue = NOT_SET_VALUE;

	int nBaseLeft = 10;

	if ( nLine >= 11 )
	{
		nBaseLeft = 300;
		nLine-=11;
	}

	// Static Setup
	pStatic->Create(szText, WS_CHILD | WS_VISIBLE | SS_RIGHT | SS_NOTIFY, CRect(nBaseLeft, 20+(nLine*30)+4, nBaseLeft+160, 20+(nLine*30)+20), this, 0x7f+nLine);
	pStatic->SetFont(m_pStandardFont);
	m_pToolTips->AddTool(pStatic, szDescription);

	// Combo Setup
	if ( !bEdit )
	{
		pCombo	= new CComboBox;
		pCombo->Create(WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_VSCROLL, CRect(nBaseLeft+170, 20+(nLine*30), nBaseLeft+170+70, 20+(nLine*30)+50+100), this, 0xff+nLine);
		pCombo->SetFont(m_pStandardFont);
		m_pToolTips->AddTool(pCombo, szOptions);
	
		// Add Strings to Combo
		Reg.ReadDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)szText, &dwValue);
		
		pCombo->AddString(NOT_SET_TEXT);
		for ( int i = 0; i != MAX_VALUES; i++ )
		{
			if ( nPossibleValues[i] == NOT_SET_VALUE )
				break;
			CString csValue;
			csValue.Format("%d", nPossibleValues[i]);
			pCombo->AddString(csValue);
		}	


		if ( dwValue == NOT_SET_VALUE )
			pCombo->SetCurSel(0);
		else
		{
			CString csValue;
			csValue.Format("%d", dwValue);

			int nFind = pCombo->FindString(0, csValue);
			if ( nFind >= 0 )
				pCombo->SetCurSel(nFind);
			else
				pCombo->SetCurSel(0);
		}
	}
	else
	{
		// Edit Setup
		pEdit = new CEdit;
		pEdit->CreateEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL, CRect(nBaseLeft+170, 20+(nLine*30), nBaseLeft+170+70, 20+(nLine*30)+20), this, 0xff+nLine);
		pEdit->SetFont(m_pStandardFont);
		m_pToolTips->AddTool(pEdit, szOptions);

		Reg.ReadDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)szText, &dwValue);

		if ( dwValue == NOT_SET_VALUE )
			dwValue = nPossibleValues[1];
		CString csValue;
		csValue.Format("%d", dwValue);
		pEdit->SetWindowText(csValue);
	}
	

	CVC1Controls VC1Controls;
	VC1Controls.pComboBox	= pCombo;
	VC1Controls.pStatic		= pStatic;
	VC1Controls.pEdit		= pEdit;

	m_vecVC1Controls.push_back(VC1Controls);
}

BOOL CVC1OptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Fonts
	m_pStandardFont = new CFont;
	m_pStandardFont->CreatePointFont(80, "MS Sans Serif");

	// ToolTips
	m_pToolTips = new CToolTipCtrl();
	m_pToolTips->Create(this);
	m_pToolTips->SetDelayTime(TTDT_AUTOPOP, 8*1000);
	m_pToolTips->SetMaxTipWidth(1024);
	m_pToolTips->Activate(TRUE);

	for ( int i = 0; i != sizeof(VC1Options)/sizeof(stVC1Options); i++ )
	{
		CreateOption(VC1Options[i].szName, i, VC1Options[i].szDescription, VC1Options[i].szOptions, VC1Options[i].nPossibleValues, VC1Options[i].nPossibleValues[0] == EDIT_BOX);
	}
/*
	CreateOption("Compression Optimization Type", 0);
	CreateOption("DenoiseOption", 1);
	CreateOption("Dquant Option", 2);
	CreateOption("Dquant Strength", 3);
	CreateOption("Force LoopFilter", 4);
	CreateOption("Force B Frame Delta QP", 5);
	CreateOption("Force NoiseEdgeRemoval", 6);
	CreateOption("Force NumThreads", 7);
	CreateOption("Force Range Reduction", 8);
	CreateOption("Force NoiseEdgeRemoval", 9);
	CreateOption("Force NumThreads", 10);
	CreateOption("Force Range Reduction", 11);
	CreateOption("Force Overlap", 12);

	CreateOption("Force Video Scaling", 13);
	CreateOption("Lookahead", 14);
	CreateOption("Macroblock Mode Cost Method", 15);
	CreateOption("Motion Match Method", 16);
	CreateOption("Motion Search Level", 17);
	CreateOption("Motion Search Range", 18);
	CreateOption("Motion Vector Coding Method", 19);
	CreateOption("Motion Vector Cost Method", 20);
	CreateOption("NumBFrames", 21);
	CreateOption("Perceptual Option", 22);
	CreateOption("Video Type", 23);
*/
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CVC1OptionsDlg::PreTranslateMessage(MSG* pMsg) 
{
	if( m_pToolTips )
       m_pToolTips->RelayEvent(pMsg);
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CVC1OptionsDlg::OnCancel() 
{
	Free();
	CDialog::OnCancel();
}

void CVC1OptionsDlg::Free()
{
	if ( m_pToolTips )
	{
		delete m_pToolTips;
		m_pToolTips = NULL;
	}

	if ( m_pStandardFont )
	{
		delete m_pStandardFont;
		m_pStandardFont = NULL;
	}

	for ( int i = 0; i != m_vecVC1Controls.size(); i++ )
	{
		if ( m_vecVC1Controls[i].pComboBox )
			delete m_vecVC1Controls[i].pComboBox;
		if ( m_vecVC1Controls[i].pStatic )
			delete m_vecVC1Controls[i].pStatic;
		if ( m_vecVC1Controls[i].pEdit )
			delete m_vecVC1Controls[i].pEdit;
	}
}

void CVC1OptionsDlg::OnOK() 
{
	CRegCntrl Reg;

	Reg.WriteDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", "Nick", 1);

	Reg.DeleteValue(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", "Nick");

	// Cycle through the controls and apply the settings
	for ( int i = 0; i != m_vecVC1Controls.size(); i++ )
	{	
		CString csValue;

		if ( m_vecVC1Controls[i].pComboBox )
		{
			m_vecVC1Controls[i].pComboBox->GetLBText(m_vecVC1Controls[i].pComboBox->GetCurSel(), csValue);

			if ( csValue == NOT_SET_TEXT )
				Reg.DeleteValue(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)VC1Options[i].szName);
			else
			{
				DWORD dwValue;
				dwValue = atoi(csValue);
				Reg.WriteDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)VC1Options[i].szName, dwValue);
			}
		}
		else
		if ( m_vecVC1Controls[i].pEdit )
		{
			m_vecVC1Controls[i].pEdit->GetWindowText(csValue);

			DWORD dwValue;
			dwValue = atoi(csValue);
			Reg.WriteDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)VC1Options[i].szName, dwValue);
		}

	}


	Free();
	CDialog::OnOK();
}

// Hack: Utter HACK-Tastic Hack. V.Bad, but it's Sunday. And I'm feeling lazy.
void CVC1OptionsDlg::OnSelChangeCOT()
{
	CString csValue;
	CString csSearch;
	CString csSetTo;

	if ( m_vecVC1Controls[0].pComboBox->GetCurSel() == 2 )
	{
		// Motion Search Level = 1
		csSearch = "Motion Search Level";
		csSetTo = "1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

		// Motion Match Method = -1
		csSearch = "Motion Match Method";
		csSetTo = "-1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

		// Dquant Option = 2
		csSearch = "Dquant Option";
		csSetTo = "2";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));
		
		// Motion Search Range = -1
		csSearch = "Motion Search Range";
		csSetTo = "-1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

		// NumBFrames = 1
		csSearch = "NumBFrames";
		csSetTo = "1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

		// Motion Vector Cost Method = 1
		csSearch = "Motion Vector Coding Method";		// NOTE: Change from Cost -> Coding
		csSetTo = "1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

		// Force LoopFilter = 1
		csSearch = "Force LoopFilter";
		csSetTo = "1";
		m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetLBText(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->GetCurSel(), csValue);
		if ( csValue == NOT_SET_TEXT )
			m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->SetCurSel(m_vecVC1Controls[FindOptionNum(csSearch)].pComboBox->FindString(0, csSetTo));

	}
}