// WMNicEncDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WMNicEnc.h"
#include "WMNicEncDlg.h"

#include "Macros.h"
#include "assert.h"
#include <wmcodecconst.h>
//#include "ControlPositionTable.h"
#include <Mmreg.h>
#include "tchar.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
HANDLE hEncThread = NULL;

bool bUseMultiPass = false;
bool bEncoding = false;

CUncompAVIToWMV *pConverter = NULL;

struct ENCPARAMS
{
	char szIn[260];
	char szOut[260];
	IWMProfile* pProfile;
} EncParams;

void Msg(char *szFormat, ...)
{
    TCHAR szBuffer[512];  // Large buffer for very long filenames (like with HTTP)

    va_list pArgs;
    va_start(pArgs, szFormat);
    vsprintf(szBuffer, szFormat, pArgs);
    va_end(pArgs);

	//printf("\nDShowErr: %s\n", szBuffer);
    MessageBox(NULL, szBuffer, NULL, MB_OK);
}

#define JIF(x) if (FAILED(hr=(x))) \
    {Msg(TEXT("FAILED(hr=0x%x) in ") TEXT(#x) TEXT("\n"), hr);}


/////////////////////////////////////////////////////////////////////////////
// CWMNicEncDlg dialog

CWMNicEncDlg::CWMNicEncDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWMNicEncDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWMNicEncDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_nProgressive = 0;

	// Init COM!
	HRESULT hr;
	JIF(CoInitialize(NULL));
	m_pCodecInfo = NULL;
	bUseAudio = true;
	bUseVideo = true;
	bUseInputSize = true;
	bUseVBR = false;
	bUseMaxBitrate = false;
	bUseVBRBox = false;
	bUseMultiPass = false;
}

void CWMNicEncDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWMNicEncDlg)
	DDX_Control(pDX, IDC_BUTTON1, m_EncodeButton);
	DDX_Control(pDX, IDC_PROGRESS1, m_ProgBar);
	DDX_Control(pDX, IDC_OUTPUTFILE, m_OutputFile);
	DDX_Control(pDX, IDC_INPUTFILE, m_InputFile);
	DDX_Control(pDX, IDC_WIDTH, m_Width);
	DDX_Control(pDX, IDC_VBRQUAL, m_VBRQuality);
	DDX_Control(pDX, IDC_FPS, m_FPS);
	DDX_Control(pDX, IDC_MAXBITRATE, m_MaxBitrate);
	DDX_Control(pDX, IDC_MAXBITRATECHECK, m_MaxBitrateButton);
	DDX_Control(pDX, IDC_USEVBR, m_UseVBRButton);
	DDX_Control(pDX, IDC_USEINPUTSIZE, m_UseInputSizeButton);
	DDX_Control(pDX, IDC_VIDEOVBRBOX, m_VideoVBRBox);
	DDX_Control(pDX, IDC_QUALITY, m_Quality);
	DDX_Control(pDX, IDC_SECKF, m_SecKF);
	DDX_Control(pDX, IDC_HEIGHT, m_Height);
	DDX_Control(pDX, IDC_BITRATE, m_Bitrate);
	DDX_Control(pDX, IDC_USEVIDEO, m_UseVideoBox);
	DDX_Control(pDX, IDC_USEAUDIO, m_UseAudioBox);
	DDX_Control(pDX, IDC_VIDEOCODEC, m_VideoCodec);
	DDX_Control(pDX, IDC_AUDIOFORMAT, m_AudioFormat);
	DDX_Control(pDX, IDC_AUDIOCODEC, m_AudioCodec);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWMNicEncDlg, CDialog)
	//{{AFX_MSG_MAP(CWMNicEncDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_CBN_SELCHANGE(IDC_AUDIOCODEC, OnSelchangeAudiocodec)
	ON_BN_CLICKED(IDC_USEAUDIO, OnUseaudio)
	ON_BN_CLICKED(IDC_USEVIDEO, OnUsevideo)
	ON_BN_CLICKED(IDC_USEINPUTSIZE, OnUseinputsize)
	ON_BN_CLICKED(IDC_USEVBR, OnUsevbr)
	ON_BN_CLICKED(IDC_MAXBITRATECHECK, OnMaxbitratecheck)
	ON_CBN_SELCHANGE(IDC_VIDEOVBRBOX, OnSelchangeVideovbrbox)
	ON_BN_CLICKED(IDC_INPUTBROWSE, OnInputbrowse)
	ON_BN_CLICKED(IDC_OUTPUTBROWSE, OnOutputbrowse)
	ON_BN_CLICKED(IDC_MULTIPASS, OnMultipass)
	ON_BN_CLICKED(IDC_ADVOPTION, OnAdvoption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWMNicEncDlg message handlers

BOOL CWMNicEncDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	HMODULE hDLL = LoadLibrary("AviSynth.DLL");
	if ( hDLL == NULL )
	{
		MessageBox("AviSynth is not installed!\r\nPlease Install AviSynth & ensure that AviSynth.dll is in the Windows System directory");
		EndDialog(0);
	}
	FreeLibrary(hDLL);

	HRESULT hr;
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	JIF(EnsureIWMCodecInfo3( &m_pCodecInfo ));	

	m_UseAudioBox.SetCheck(TRUE);
	m_UseVideoBox.SetCheck(TRUE);

	// Setup video Boxes
	m_Bitrate.SetWindowText("600000");
	m_Quality.SetWindowText("100");
	m_FPS.SetWindowText("25");
	m_SecKF.SetWindowText("5");

	m_UseInputSizeButton.SetCheck(TRUE);
	m_Width.SetWindowText("352");
	m_Height.SetWindowText("288");

	m_VBRQuality.SetWindowText("100");
	m_VideoVBRBox.AddString("Quality");
	m_VideoVBRBox.AddString("Constrained");
	m_VideoVBRBox.AddString("Unconstrained");
	m_VideoVBRBox.SetCurSel(0);




	// Get Audio Codec Count
	DWORD dwCodecCount;
	m_pCodecInfo->GetCodecInfoCount( WMMEDIATYPE_Audio, &dwCodecCount );
	

    m_AudioCodec.ResetContent();
	WCHAR *wszCodecName = NULL;
	CString strCodecName;
    for ( DWORD dwCodecIndex = 0; dwCodecIndex < dwCodecCount; dwCodecIndex++ )
    {
  	    //
        // Get the name for the codec
        //
        DWORD dwCodecNameLength = 0;
        hr = m_pCodecInfo->GetCodecName( WMMEDIATYPE_Audio, dwCodecIndex, NULL, &dwCodecNameLength );
        if ( FAILED( hr ) )
        {
            break;
        }

        SAFE_ARRAYDELETE( wszCodecName );
        wszCodecName = new WCHAR[ dwCodecNameLength + 1 ];
        if ( !wszCodecName )
        {
            hr = E_OUTOFMEMORY;
            break;
        }

        hr = m_pCodecInfo->GetCodecName( WMMEDIATYPE_Audio, dwCodecIndex, wszCodecName, &dwCodecNameLength );
        if ( FAILED( hr ) )
        {
            break;
        }
        wszCodecName[ dwCodecNameLength ] = L'\0'; // terminate the codec name, just in case

        strCodecName.Format( _T( "%ls" ), wszCodecName );

        DWORD nCodecStringIndex = m_AudioCodec.AddString( strCodecName );
        if ( CB_ERR == nCodecStringIndex )
        {
            hr = E_UNEXPECTED;
            break;
        }
        m_AudioCodec.SetItemData( nCodecStringIndex, dwCodecIndex );
    }

	SAFE_ARRAYDELETE( wszCodecName );

	// Now populate the Video Codec Combo
	m_pCodecInfo->GetCodecInfoCount( WMMEDIATYPE_Video, &dwCodecCount );

    m_VideoCodec.ResetContent();
    for ( dwCodecIndex = 0; dwCodecIndex < dwCodecCount; dwCodecIndex++ )
    {
        DWORD dwCodecNameLength = 4;
        hr = m_pCodecInfo->GetCodecName( WMMEDIATYPE_Video, dwCodecIndex, NULL, &dwCodecNameLength );
        if ( FAILED( hr ) )
        {
            break;
        }

        SAFE_ARRAYDELETE( wszCodecName );
        wszCodecName = new WCHAR[ dwCodecNameLength + 1 ];
        if ( !wszCodecName )
        {
            hr = E_OUTOFMEMORY;
            break;
        }

        hr = m_pCodecInfo->GetCodecName( WMMEDIATYPE_Video, dwCodecIndex, wszCodecName, &dwCodecNameLength );
        if ( FAILED( hr ) )
        {
            break;
        }
        wszCodecName[ dwCodecNameLength ] = L'\0'; // terminate the codec name, just in case

        strCodecName.Format( _T( "%ls" ), wszCodecName );

        int nCodecStringIndex = m_VideoCodec.AddString( strCodecName );
        if ( CB_ERR == nCodecStringIndex )
        {
            continue;
        }
        m_VideoCodec.SetItemData( nCodecStringIndex, dwCodecIndex );
    }

	SAFE_ARRAYDELETE( wszCodecName );

	PopulateAudioFormatCB( 0 ); // Adds the formats of the audio codec
	
	m_AudioFormat.SetCurSel(0);
	m_AudioCodec.SetCurSel(0);
	m_VideoCodec.SetCurSel(0);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWMNicEncDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWMNicEncDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

DWORD WINAPI EncProc(LPVOID lpParameter)
{
	CoInitialize(NULL);
	CWMNicEncDlg *This = (CWMNicEncDlg *)lpParameter;
	HRESULT hr;
	CUncompAVIToWMV converter;
	pConverter = &converter;
	converter.SetProgressHandle(This->m_ProgBar.m_hWnd);
	This->m_EncodeButton.SetWindowText("Stop");
	if ( bUseMultiPass )
		converter.SetPreprocessing(TRUE);

	switch ( This->m_nProgressive  )
	{
	case 0:
		break;
	case 1:
		converter.bDeinterlace = true;
		break;
	case 2:
		converter.bIVTC = true;
		break;
	default:
		break;
	}

	JIF(converter.Initial( EncParams.szIn, 
						   FALSE,		// use FALSE (just one file)
						   EncParams.szOut, 
						   EncParams.pProfile, 
						   FALSE,		// Use FALSE
						   TRUE,		// Use TRUE
						   FALSE,		// Use False
						   -1 ));


	bEncoding = true;
	converter.Start();
	bEncoding = false;
	pConverter = NULL;

	This->m_EncodeButton.SetWindowText("Encode");
	::SendMessage(This->m_ProgBar.m_hWnd, PBM_SETPOS, 0, 0);

	SAFE_RELEASE(EncParams.pProfile);
	CoUninitialize();
	return 0;
}




void CWMNicEncDlg::OnButton1() 
{
	if ( bEncoding )
	{
		if ( pConverter )
			pConverter->Stop();
	}
	else
	{
		// Create Profile
		HRESULT hr;
		IWMProfile3* pProfile3 = NULL;
		IWMProfile* pProfile = NULL;
		IWMProfileManager* pProfileManager = NULL;
		DWORD dwRegValue = 500;
		CRegCntrl Reg;

		JIF(WMCreateProfileManager( &pProfileManager ));
		JIF(pProfileManager->CreateEmptyProfile( WMT_VER_9_0, &pProfile ));
		JIF(pProfile->QueryInterface( IID_IWMProfile3, (void**) &pProfile3 ));

		JIF(pProfile->SetName(L"Profile"));
		JIF(pProfile->SetDescription(L"Description"));

		// Add an audio stream
		IWMStreamConfig* pNewStreamConfig = NULL;

		if ( bUseAudio )
		{
			DWORD dwAudioIndex = m_AudioFormat.GetItemData( m_AudioFormat.GetCurSel() );
			
			int a;
			a = dwAudioIndex % VBR_OFFSET;
			a = dwAudioIndex / VBR_OFFSET > 0;
			a = dwAudioIndex / VBR_OFFSET;
	
			JIF( CreateAudioStream(     &pNewStreamConfig, 
										m_pCodecInfo, 
										pProfile,
										3000,								// buffer windows
										m_AudioCodec.GetCurSel(),			// codec index
										dwAudioIndex % VBR_OFFSET,			// formatindex
										dwAudioIndex / VBR_OFFSET > 0,		// isVBR
										dwAudioIndex / VBR_OFFSET,
										GetSystemDefaultLCID())
										);		// number of passes

			JIF(pNewStreamConfig->SetStreamNumber(1));
			JIF(pNewStreamConfig->SetStreamName(L"Audio"));
			JIF(pNewStreamConfig->SetConnectionName(L"AudioConnect"));
			JIF(pProfile->AddStream( pNewStreamConfig ));
			pNewStreamConfig->Release();
			pNewStreamConfig = NULL;
		}

		CString szInName, szOutName;
		m_InputFile.GetWindowText(szInName);
		m_OutputFile.GetWindowText(szOutName);

		if  ( bUseVideo )
		{
			PAVIFILE pAVIFileIn = NULL;
			PAVISTREAM pVideoStream = NULL;
			AVISTREAMINFO videoStreamInfo;

			int Err;
			AVIFileInit();
			
			
			Err = AVIFileOpen(&pAVIFileIn, szInName, OF_READ | OF_SHARE_DENY_NONE, NULL);
			if ( Err )
				MessageBox("Could not open input file!", 0, 0);

			Err = AVIFileGetStream( pAVIFileIn, &pVideoStream, streamtypeVIDEO, 0);
			if ( Err )
				MessageBox("Could not open input stream!", 0, 0);

			Err = AVIStreamInfo( pVideoStream, &videoStreamInfo, sizeof( videoStreamInfo ) );
			if ( Err )
				MessageBox("Cant get input stream info!", 0, 0);

			pVideoStream->Release();
			AVIFileClose(pAVIFileIn);
			AVIFileExit();

			CString csTemp;
			int width, height;
			if ( bUseInputSize )
			{
				width = videoStreamInfo.rcFrame.right - videoStreamInfo.rcFrame.left;
				height = videoStreamInfo.rcFrame.bottom - videoStreamInfo.rcFrame.top;
			}
			else
			{
				m_Width.GetWindowText(csTemp);
				width = atoi(csTemp);
				m_Height.GetWindowText(csTemp);
				height = atoi(csTemp);
			}


			VIDEO_VBR_MODE vbr_mode = VBR_OFF;

			if ( bUseVBR )
			{
				vbr_mode = (VIDEO_VBR_MODE)(m_VideoVBRBox.GetCurSel()+1);
			}

			int vbrquality = 0;
			int maxbitrate = 0;

			if ( bUseVBR )
			{
				m_VBRQuality.GetWindowText(csTemp);
				vbrquality = atoi(csTemp);

				m_MaxBitrate.GetWindowText(csTemp);
				maxbitrate = atoi(csTemp);
			}
			
			m_Bitrate.GetWindowText(csTemp);
			int bitrate = atoi(csTemp);
			m_FPS.GetWindowText(csTemp);
			double fps = atof(csTemp);
			m_SecKF.GetWindowText(csTemp);
			int seckf = atoi(csTemp);
			m_Quality.GetWindowText(csTemp);
			int quality = atoi(csTemp);

			// Create Video Stream
			hr = CreateVideoStream( &pNewStreamConfig,
										m_pCodecInfo,
										pProfile,
										m_VideoCodec.GetCurSel(),		// codec index
										bitrate,							// bitrate
										3000,	// buffer window
										width,	// width
										height,	// height
										fps,		// fps
										quality,	// video quality
										seckf,		// seconds per keyframes
										bUseVBR,	// video is VBR
										vbr_mode,	// VBR mode ( VIDEO_VBR_MODE )
										vbrquality,	// VBR Quality
										maxbitrate,	// Max Bitrate (VBR)
										10000,
										GetSystemDefaultLCID());		// Max VBR Video Buffer

			JIF(pNewStreamConfig->SetStreamNumber(2));
			JIF(pNewStreamConfig->SetStreamName(L"Video"));
			JIF(pNewStreamConfig->SetConnectionName(L"VideoConnect"));

			// Buffer Window Size
			dwRegValue = 3000;
			Reg.ReadDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)SPECIAL_BUFFER_WINDOW_SIZE, &dwRegValue);
			JIF(pNewStreamConfig->SetBufferWindow(dwRegValue));

			// Complexity
			
			// See if there are Complexity settings in the registry
			dwRegValue = 500;
			Reg.ReadDWORD(HKEY_CURRENT_USER, "Software\\Microsoft\\Scrunch\\WMVideo", (char*)SPECIAL_COMPLEXITY_SETTING, &dwRegValue);

			if ( dwRegValue != 500 )
			{
				IWMPropertyVault *pPropertyVault = NULL;
				HRESULT hr = pNewStreamConfig->QueryInterface(&pPropertyVault);
				if ( SUCCEEDED(hr) )
				{
					// Check Maximum Complexity
					WMT_ATTR_DATATYPE dataType = WMT_TYPE_DWORD;
					DWORD dwSize = sizeof(DWORD);
					DWORD dwMaxComplexity = 0;
					hr = m_pCodecInfo->GetCodecProp(WMMEDIATYPE_Video, 
													m_VideoCodec.GetCurSel(), 
													g_wszComplexityMax,
													&dataType,
													(BYTE*)&dwMaxComplexity,
													&dwSize);





					// Set Complexity
					WORD wComplexity = (dwRegValue > dwMaxComplexity) ? (WORD)dwMaxComplexity : (WORD)dwRegValue;
					hr = pPropertyVault->SetProperty(g_wszComplexity, WMT_TYPE_WORD, (BYTE*)&wComplexity, sizeof(WORD));


					/*// Make sure we set complexity ok
					dwSize = sizeof(WORD);
					dataType = WMT_TYPE_WORD;
					hr = pPropertyVault->GetPropertyByName(g_wszComplexity, &dataType, (BYTE*)&wComplexity, &dwSize);*/
				}
			}

			



			JIF(pProfile->AddStream( pNewStreamConfig ));
			pNewStreamConfig->Release();
			pNewStreamConfig = NULL;
		}

		strcpy(EncParams.szIn, szInName.GetBuffer(0));
		strcpy(EncParams.szOut, szOutName.GetBuffer(0));
		EncParams.pProfile = pProfile;


		if ( hEncThread )
			CloseHandle(hEncThread);

		DWORD dwThreadID;
		hEncThread = CreateThread(NULL,
								  0,
								  EncProc,//(LPTHREAD_START_ROUTINE)&(CMpeg2EncGUIDlg::MPEGEncodeProc),
								  this,
								  0,
								  &dwThreadID );

		SAFE_RELEASE( pProfile3 );
		SAFE_RELEASE( pProfileManager );
	}

	// Use -1
/*	
	//pProfile->AddRef();
	// Save profile
	DWORD dwProfileDataLength = 0;
    JIF(pProfileManager->SaveProfile( pProfile, NULL, &dwProfileDataLength ));

	WCHAR *wszProfileData = new WCHAR[ dwProfileDataLength + 1 ];

    JIF(pProfileManager->SaveProfile( pProfile, wszProfileData, &dwProfileDataLength ));

    JIF(WriteProfileAsPRX( "e:\\test.prx", wszProfileData, dwProfileDataLength * sizeof( WCHAR ) ));
	*/


}

BOOL CWMNicEncDlg::DestroyWindow() 
{
	// De-Init COM!
	CoUninitialize();
	
	return CDialog::DestroyWindow();
}

void CWMNicEncDlg::OnSelchangeAudiocodec() 
{
	PopulateAudioFormatCB( m_AudioCodec.GetCurSel() ); // Adds the formats of the codec
	
	m_AudioFormat.SetCurSel(0);
}

void CWMNicEncDlg::OnUseaudio() 
{
	bUseAudio = !bUseAudio;
	m_AudioCodec.EnableWindow(bUseAudio);
	m_AudioFormat.EnableWindow(bUseAudio);
}

void CWMNicEncDlg::OnUsevideo() 
{
	bUseVideo = !bUseVideo;

	if ( bUseVideo )
	{
		m_VideoCodec.EnableWindow(TRUE);

		m_Bitrate.EnableWindow(TRUE);
		m_FPS.EnableWindow(TRUE);
		m_SecKF.EnableWindow(TRUE);
		m_Quality.EnableWindow(TRUE);

		m_UseInputSizeButton.EnableWindow(TRUE);
		if ( !bUseInputSize )
		{
			m_Width.EnableWindow(TRUE);
			m_Height.EnableWindow(TRUE);
		}

		m_UseVBRButton.EnableWindow(TRUE);
		if ( bUseVBR )
		{
			m_VideoVBRBox.EnableWindow(TRUE);
			m_VBRQuality.EnableWindow(TRUE);
			m_MaxBitrateButton.EnableWindow(TRUE);
			m_MaxBitrate.EnableWindow(bUseMaxBitrate);
		}
	}
	else
	{
		m_VideoCodec.EnableWindow(FALSE);
	
		m_Bitrate.EnableWindow(FALSE);
		m_FPS.EnableWindow(FALSE);
		m_SecKF.EnableWindow(FALSE);
		m_Quality.EnableWindow(FALSE);
		m_Width.EnableWindow(FALSE);
		m_Height.EnableWindow(FALSE);
		m_UseInputSizeButton.EnableWindow(FALSE);

		m_UseVBRButton.EnableWindow(FALSE);
		m_VideoVBRBox.EnableWindow(FALSE);
		m_VBRQuality.EnableWindow(FALSE);
		m_MaxBitrateButton.EnableWindow(FALSE);
		m_MaxBitrate.EnableWindow(FALSE);
	}
}

void CWMNicEncDlg::OnUseinputsize() 
{
	bUseInputSize = !bUseInputSize;	
	
	m_Width.EnableWindow(!bUseInputSize);
	m_Height.EnableWindow(!bUseInputSize);
}

void CWMNicEncDlg::OnUsevbr() 
{
	bUseVBR = !bUseVBR;
	m_VideoVBRBox.EnableWindow(bUseVBR);
	m_VBRQuality.EnableWindow(bUseVBR);
	if ( m_VideoVBRBox.GetCurSel() == 1 )
	{
		m_MaxBitrateButton.EnableWindow(bUseVBR);
		m_MaxBitrate.EnableWindow(bUseMaxBitrate);
	}
}

void CWMNicEncDlg::OnMaxbitratecheck() 
{
	bUseMaxBitrate = !bUseMaxBitrate;
	m_MaxBitrate.EnableWindow(bUseMaxBitrate);
}

void CWMNicEncDlg::OnSelchangeVideovbrbox() 
{
	if ( m_VideoVBRBox.GetCurSel() == 1 )
	{
		m_MaxBitrateButton.EnableWindow(TRUE);
		m_MaxBitrate.EnableWindow(TRUE);
	}
	else
	{
		m_MaxBitrateButton.EnableWindow(FALSE);
		m_MaxBitrate.EnableWindow(FALSE);
	}
}

void CWMNicEncDlg::OnInputbrowse() 
{
	CFileDialog dlg( TRUE, "avs", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "AVS Files (*.avs)|*.avs|All Files (*.*)|*.*||", this);
		
	if ( dlg.DoModal() == IDOK )
	{
		UpdateData(TRUE);

		CString path = dlg.GetPathName();
		m_InputFile.SetWindowText(path);

		// Set Output Automatically
		CString csExt = ".wmv";
		if ( m_UseAudioBox.GetCheck() == BST_CHECKED && m_UseVideoBox.GetCheck() == BST_UNCHECKED )
			csExt = ".wma";

		int nDot = path.ReverseFind('.');
		if ( nDot != -1 )
		{
			path = path.Left(nDot);
			path += csExt;
			m_OutputFile.SetWindowText(path);
		}
		
		UpdateData(FALSE);
	}
}

void CWMNicEncDlg::OnOutputbrowse() 
{
	CFileDialog dlg( FALSE, "wmv", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "WMV Files (*.wmv)|*.wmv|All Files (*.*)|*.*||", this);
		
	if ( dlg.DoModal() == IDOK )
	{
		CString path = dlg.GetPathName();
		m_OutputFile.SetWindowText(path);
	}
	
}

void CWMNicEncDlg::OnMultipass() 
{
	bUseMultiPass = !bUseMultiPass;
}

void CWMNicEncDlg::OnAdvoption() 
{
	/*
	CAdvVideoOptions dlg;
	
	dlg.m_Progressive = m_nProgressive;
	if ( dlg.DoModal() == IDOK )
	{
		m_nProgressive = dlg.m_Progressive;
		if ( m_nProgressive == 2 ) // if IVTC set to 24 fps
		{
			m_FPS.SetWindowText("23.976");
		}
	}
	*/

	CVC1OptionsDlg dlg;
	dlg.DoModal();
}
