// WMNicEncDlg.h : header file
//

#if !defined(AFX_WMNICENCDLG_H__E56D903C_4C2B_428D_913D_74C8F3A95F03__INCLUDED_)
#define AFX_WMNICENCDLG_H__E56D903C_4C2B_428D_913D_74C8F3A95F03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GenProfile_lib.h"
#include "ProfileObject.h"

#include "UncompAVIToWMV.h"
#include "AdvVideoOptions.h"
#include "VC1OptionsDlg.h"

#define VBR_OFFSET 5000 // The offset used to tell if a particular format is VBR and how many passes it is

void Msg(char *szFormat, ...);

/////////////////////////////////////////////////////////////////////////////
// CWMNicEncDlg dialog

class CWMNicEncDlg : public CDialog
{
// Construction
public:
	CWMNicEncDlg(CWnd* pParent = NULL);	// standard constructor
	HRESULT AddAudioFormatsToCB( BOOL fIsVBR, DWORD dwNumVBRPasses, DWORD dwCodecIndex );
	DWORD GetNumberOfFormatsSupported( GUID guidStreamType,
                                       DWORD dwCodecIndex, 
                                       BOOL fIsVBR, 
                                       DWORD dwNumPasses );
	STDMETHODIMP SetCodecVBRSettings( IWMCodecInfo3* pCodecInfo3, 
									  GUID guidCodecType, 
									  DWORD dwCodecIndex, 
									  BOOL bIsVBR, 
									  DWORD dwVBRPasses );
	HRESULT PopulateAudioFormatCB( DWORD dwCodecIndex );


	int m_nProgressive;
// Dialog Data
	//{{AFX_DATA(CWMNicEncDlg)
	enum { IDD = IDD_WMNICENC_DIALOG };
	CButton	m_EncodeButton;
	CProgressCtrl	m_ProgBar;
	CEdit	m_OutputFile;
	CEdit	m_InputFile;
	CEdit	m_Width;
	CEdit	m_VBRQuality;
	CEdit	m_FPS;
	CEdit	m_MaxBitrate;
	CButton	m_MaxBitrateButton;
	CButton	m_UseVBRButton;
	CButton	m_UseInputSizeButton;
	CComboBox	m_VideoVBRBox;
	CEdit	m_Quality;
	CEdit	m_SecKF;
	CEdit	m_Height;
	CEdit	m_Bitrate;
	CButton	m_UseVideoBox;
	CButton	m_UseAudioBox;
	CComboBox	m_VideoCodec;
	CComboBox	m_AudioFormat;
	CComboBox	m_AudioCodec;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWMNicEncDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation

protected:

	bool bUseAudio, bUseVideo;
	bool bUseInputSize;
	bool bUseVBR;
	bool bUseMaxBitrate;
	bool bUseVBRBox;

	HICON m_hIcon;
	IWMCodecInfo3* m_pCodecInfo;

	// Generated message map functions
	//{{AFX_MSG(CWMNicEncDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();
	afx_msg void OnSelchangeAudiocodec();
	afx_msg void OnUseaudio();
	afx_msg void OnUsevideo();
	afx_msg void OnUseinputsize();
	afx_msg void OnUsevbr();
	afx_msg void OnMaxbitratecheck();
	afx_msg void OnSelchangeVideovbrbox();
	afx_msg void OnInputbrowse();
	afx_msg void OnOutputbrowse();
	afx_msg void OnMultipass();
	afx_msg void OnAdvoption();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WMNICENCDLG_H__E56D903C_4C2B_428D_913D_74C8F3A95F03__INCLUDED_)
